zoukankan      html  css  js  c++  java
  • LeetCode -- Unique Paths

    Question:

    A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

    The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

    How many possible unique paths are there?

    Above is a 3 x 7 grid. How many possible unique paths are there?

    Note: m and n will be at most 100.

     Analysis:

    一个机器人在 m * n 网格的左上角(由start标识),每次这个机器人只能向右或向下移动,尝试到达网格的右下角(由finish标识)。

    这里有多少条可能的不同的路径?

    注意: m 和 n 都小于100.

    思路:由于之前做过求最短路径的问题,所以很容易的想到动态规划的思想。

    Answer:

    public class Solution {
        public int uniquePaths(int m, int n) {
            if(m == 0 && n == 0)
                return 0;
            if(m == 1 || n == 1) return 1;
            int[][] dp = new int[m][n];
            dp[0][0] = 1;
            for(int i=0; i<m; i++) {
                for(int j=0; j<n; j++) {
                    if(i == 0 && j == 0)
                        continue;
                    else if(i == 0 && j != 0)
                        dp[i][j] = dp[i][j-1];
                    else if(i != 0 && j == 0)
                        dp[i][j] = dp[i-1][j];
                    else 
                        dp[i][j] = dp[i-1][j] + dp[i][j-1];
                }
            }
            return dp[m-1][n-1];
        }
    }
     
  • 相关阅读:
    高斯消元
    逻辑运算符之优先级&&and、or
    康托展开
    关于bootstrap的双层遮罩问题
    写好页面在内网内访问
    swiper插件的一些坑
    第一篇博客
    poj 3415 Common Substrings
    poj 1509 Glass Beads
    poj 3260 The Fewest Coins
  • 原文地址:https://www.cnblogs.com/little-YTMM/p/5216615.html
Copyright © 2011-2022 走看看